package soccerTeamExample_textbookVersion;

import java.util.List;
import java.util.Vector;

/**
 * This class encapsulates the data attributes that represent a member of a
 * soccer team. This is taken from the example in Ch4 of the Olsen textbook. In
 * the textbook, this class is called "TeamMember"
 * 
 * @author mb
 * 
 */
public class TeamMemberModel {

	private String firstName;
	private String lastName;
	private String address;
	private String phoneNumber;

	private List<TeamMemberModelListener> listeners;

	public TeamMemberModel() {
		listeners = new Vector<TeamMemberModelListener>();
	}

	public String getFirstName() {
		return firstName;
	}

	public void setFirstName(String firstName) {
		this.firstName = firstName;
		System.out.println(this.toString());
		notifyModelHasChanged();
	}

	public String getLastName() {
		return lastName;
	}

	public void setLastName(String lastName) {
		this.lastName = lastName;
		System.out.println(this.toString());
		notifyModelHasChanged();
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
		System.out.println(this.toString());
		notifyModelHasChanged();
	}

	public String getPhoneNumber() {
		return phoneNumber;
	}

	public void setPhoneNumber(String phoneNumber) {
		this.phoneNumber = phoneNumber;
		System.out.println(this.toString());
		notifyModelHasChanged();
	}

	public void addTeamMemberListener(TeamMemberModelListener teamMemberListener) {
		listeners.add(teamMemberListener);
	}

	public void notifyModelHasChanged() {
		for (TeamMemberModelListener listener : listeners) {
			listener.changed();
		}
	}

	public String toString() {
		return firstName + ";" + lastName + ";" + address + ";" + phoneNumber;
	}

}
